#ifndef CPUCYCLES_H
#define CPUCYCLES_H

static inline uint64_t cpucycles(void) {
  uint64_t result;

  __asm__ volatile ("rdtsc; shlq $32,%%rdx; orq %%rdx,%%rax"
    : "=a" (result) : : "%rdx");

  return result;
}

static int cmp_uint64(const void *a, const void *b)
{
  if(*(uint64_t *)a < *(uint64_t *)b){ return -1; }
  if(*(uint64_t *)a > *(uint64_t *)b){ return 1; }
  return 0;
}

static uint64_t median(uint64_t *l, size_t llen)
{
  qsort(l,llen,sizeof(uint64_t),cmp_uint64);

  if(llen%2) return l[llen/2];
  else return (l[llen/2-1]+l[llen/2])/2;
}

// to be called cpucycles_median ?
static void cpucycles_result(uint64_t *cycles, size_t timings, size_t len) {
  size_t llen;
  size_t mid, lower, upper;
  uint64_t first, second, third, fourth, fifth;

  /*
  for (i = 0; i < timings - 1; i++) {
    cycles[i] = cycles[i+1] - cycles[i];
  }
  */

  llen = timings - 1;

  mid = llen / 2;
  lower = mid / 2;
  upper = (mid + llen) / 2;

  // qsort(cpucycles, llen,sizeof(uint64_t),cmp_uint64);

  first = cycles[0];
  second = mid % 2 ? (cycles[lower] + cycles[lower - 1]) / 2 : cycles[lower];
  third = llen % 2 ? (cycles[mid] + cycles[mid - 1]) / 2 : cycles[mid];
  fourth = mid % 2 ? (cycles[upper] + cycles[upper - 1]) / 2 : cycles[upper];
  fifth = cycles[llen - 1];

  printf("Bytes: %ld, min : %ld, lower: %ld, median : %ld, upper: %ld, max : %ld, \n", len, first, second, third, fourth, fifth);
}

static uint64_t cpucycles_median(uint64_t *cycles, size_t timings)
{
  size_t i;
  for (i = 0; i < timings-1; i++)
  { cycles[i] = cycles[i+1] - cycles[i]; }

  return median(cycles, timings-1);
}


#endif
