#!/usr/bin/env python3

import os
import csv
import sys

needed = {32: "a", 128 : "b", 1024: "c", 16384 : "d"}
impls = {"ref": "ref", "ref1" : "refone", "refop" : "refop", "ref1p": "refsp", "ref1pp" : "refnsp", "mmxp" : "mmxstack", "mmx1p" : "mmxmmx"}

def main():
    result = ""
    outfile = "../../../paper/tables/chacha_data.tex"
    ref_dict = {}
    for impl in impls:
        inputfile = "bin/%s/jade_stream_chacha_chacha20_amd64_%s.csv" % (impl, impl)
        with open(inputfile) as csv_file:
            csv_reader = csv.reader(csv_file, delimiter=',')
            for row in csv_reader:
                if int(row[0]) in needed:

                    cycles = "{:.2e}".format(int(row[1]))
                    if impl == "ref" :
                        ref_dict[int(row[0])] = int(row[1])
                    # cycles = row[1]
                    data = r"\newcommand*\%s%s{%s}" % (impls[impl], needed[int(row[0])], cycles)
                    result += data;
                    overhead = "{:.1f}".format((float(row[1]) - ref_dict[int(row[0])]) / ref_dict[int(row[0])] * 100)
                    data  = r"\newcommand*\%s%so{%s}" % (impls[impl], needed[int(row[0])], overhead)
                    result += data
                    # print(data)
                    result += "\n";
            # print(ref_dict)
        result += "\n"

    with open(outfile, 'w') as f:
        f.write(result)

if __name__ == "__main__":
    main()
