set term svg enhanced background rgb 'white' size 600,380
set logscale x 2

set xtics (32,64,128,256,512,1024,2048,4096,8192,16384)

set grid xtics ytics mxtics mytics
set mytics 5

set yrange [-1:20]
set xlabel "input length in bytes \n I7-6500U"
set ylabel "overhead (lower is better)"

set output "diff.svg"

plot \
"../diffs/jade_stream_chacha_chacha20_amd64_ref1pp_xor.csv" using 1:2 title 'reference - sct - non selective' with lines, \
"../diffs/jade_stream_chacha_chacha20_amd64_mmx1p_xor.csv" using 1:2 title 'reference ++ mmx - sct' with lines

unset logscale x
